
#include <iostream.h>

main() {

  /* Template parameters */

  const nProcs    = 4 ;
  const blockSize = 3 ;

  for (int s_p = 0 ; s_p < nProcs ; s_p++) {
  cout << "s_p = " << s_p << "\n";
  //const s_p       = 0 ;

  /* Range parameters */

  const base   = 4 ;
  const stride = 5 ;
  const size   = 8 ;

  /* Misc useful derived expressions */

  const int layerSize        = nProcs * blockSize ;
  const int layerSizeNegMod  =  (stride - layerSize % stride) % stride ;

  const int  s_v_min   =  (base / blockSize - s_p + nProcs - 1) / nProcs ;

  const int offset_0   = (s_v_min * nProcs + s_p) * blockSize - base ;
  const int s_h_min_0  = offset_0 < 0 ?
                             - offset_0 :
                             (stride - offset_0 % stride) % stride ;


  /* A loop */

  int s_h_min  = s_h_min_0 ;
  int s_v, offset ;

  cout << "offset_0 = " << offset_0 << "\n";
  cout << "s_h_min = " << s_h_min << "\n";

  for (s_v  =  s_v_min, offset = offset_0 ;
       offset  <  stride * size ;
       s_v++, offset  += layerSize) {

    int i_min = (offset + s_h_min) / stride ;

    for (int s_h =  s_h_min,  i = i_min ;
         s_h < blockSize  &&  i < size ;
         s_h += stride,  i++ ) {

      /* Do the business with `s_v', `s_h' and `i' */
      cout << "s_v = " << s_v << "  s_h = " << s_h << "  i = " << i << "\n";

    }
    s_h_min =  (s_h_min + layerSizeNegMod) % stride ;
  }

  }
}
